import { IConnection } from "vscode-languageserver";
import { ElmWorkspace } from "../../elmWorkspace";
import { Settings } from "../../util/settings";
import { ITextDocumentEvents } from "../../util/textDocumentEvents";
import { ElmAnalyseDiagnostics } from "./elmAnalyseDiagnostics";
import { ElmMakeDiagnostics } from "./elmMakeDiagnostics";
export interface IElmIssueRegion {
    start: {
        line: number;
        column: number;
    };
    end: {
        line: number;
        column: number;
    };
}
export interface IElmIssue {
    tag: string;
    overview: string;
    subregion: string;
    details: string;
    region: IElmIssueRegion;
    type: string;
    file: string;
}
export declare class DiagnosticsProvider {
    private connection;
    private settings;
    private events;
    private elmMakeDiagnostics;
    private elmAnalyseDiagnostics;
    private elmWorkspaceMatcher;
    private currentDiagnostics;
    constructor(connection: IConnection, elmWorkspaces: ElmWorkspace[], settings: Settings, events: ITextDocumentEvents, elmAnalyse: ElmAnalyseDiagnostics | null, elmMake: ElmMakeDiagnostics);
    private newElmAnalyseDiagnostics;
    private sendDiagnostics;
    private getDiagnostics;
}
