"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Provider {
    constructor(elmWorkspaces, getUriFor) {
        this.elmWorkspaces = elmWorkspaces;
        this.getUriFor = getUriFor;
    }
    handlerForWorkspace(handler) {
        return (param) => {
            return handler(this.getElmWorkspaceFor(param), param);
        };
    }
    getElmWorkspaceFor(param) {
        const uri = this.getUriFor(param);
        const workspace = 
        // first look for a workspace where the file has been parsed to a tree
        this.elmWorkspaces.find(ws => ws.hasDocument(uri)) ||
            // fallback: find a workspace where the file is in the source-directories
            this.elmWorkspaces.find(ws => ws.hasPath(uri));
        if (!workspace) {
            throw new Error(`No Elm workspace contains ${this.getUriFor(param).fsPath}`);
        }
        return workspace;
    }
}
exports.Provider = Provider;
//# sourceMappingURL=provider.js.map