import { URI } from "vscode-uri";
import { ElmWorkspace } from "../elmWorkspace";
/**
 * Identifies the relevant ElmWorkspace for a given ParamType, either directly
 * (getElmWorkspaceFor) or when an event handler receives a ParamType
 * (handlerForWorkspace).
 */
export declare class ElmWorkspaceMatcher<ParamType> {
    protected readonly elmWorkspaces: ElmWorkspace[];
    protected readonly getUriFor: (param: ParamType) => URI;
    constructor(elmWorkspaces: ElmWorkspace[], getUriFor: (param: ParamType) => URI);
    handlerForWorkspace<ResultType>(handler: (param: ParamType, elmWorkspace: ElmWorkspace) => ResultType): (param: ParamType) => ResultType;
    getElmWorkspaceFor(param: ParamType): ElmWorkspace;
}
